-- 	File: dyplo_types.vhd
--
--	© COPYRIGHT 2014 TOPIC EMBEDDED PRODUCTS B.V. ALL RIGHTS RESERVED.
--
--	This file contains confidential and proprietary information of
--	Topic Embedded Products B.V. and is protected under Dutch and
--	International copyright and other international intellectual property laws.
--
--	Disclaimer
--
--	This disclaimer is not a license and does not grant any rights to the
--	materials distributed herewith. Except as otherwise provided in a valid
--	license issued to you by Topic Embedded Products B.V., and to the maximum
--	extend permitted by applicable law:
--
--	1.	Dyplo is furnished on an 'as is', as available basis. Topic makes no
--	warranty, express or implied, with respect to the capability of Dyplo. All
--	warranties of any type, express or implied, including the warranties of
--	merchantability, fitness for a particular purpose and non-infringement of
--	third party rights are expressly disclaimed.
--
--	2.	Topic's maximum total liability shall be limited to general money
--	damages in an amount not to exceed the total amount paid for in the year
--	in which the damages have occurred.  Under no circumstances including
--	negligence shall Topic be liable for direct, indirect, incidental, special,
--	consequential or punitive damages, or for loss of profits, revenue, or data,
--	that are directly or indirectly related to the use of, or the inability to
--	access and use Dyplo and related services, whether in an action in contract,
--	tort, product liability, strict liability, statute or otherwise even if
--	Topic has been advised of the possibility of those damages.
--
--	This copyright notice and disclaimer must be retained as part of this file at all times.

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

library dyplo;
use dyplo.dyplo_config.all;

package test_types is
	type lane_mode_type is array (natural range <>) of natural range 0 to 3;
	type lane_destinations_type is array (natural range <>) of std_logic_vector(c_int_destination_width - 1 downto 0);

	type unsigned_matrix_4_64 is array (0 to 3) of unsigned(63 downto 0);
	type unsigned_matrix_8_4_64 is array (0 to 7) of unsigned_matrix_4_64;
	type unsigned_matrix_4_8_4_64 is array (0 to 3) of unsigned_matrix_8_4_64;

end test_types;

package body test_types is
end package body test_types;
