#!/bin/sh

rm -f fpga.bit

case "$FPGA_FAMILY" in
	xc7z015)
		export PART=${FPGA_FAMILY}clg485-1
		;;
	xc7z030)
		export PART=${FPGA_FAMILY}sbg485-1
		;;
	*)
		echo "Environment variable FPGA_FAMILY=$FPGA_FAMILY is not valid"
		echo "Valid are: xc7z015 xc7z030"
		exit 1
		;;
esac

# Unzip Dyplo
pushd IP/dyplo
unzip -o TEP_dyplo*.zip
popd

VIVADO_TCL="vivado -nolog -nojournal -mode batch -notrace -source"

$VIVADO_TCL generate_bitstream.tcl -tclargs ${PART}

cp ${PART}/${PART}.runs/impl_1/*.bit fpga.bit
