# ============================= LCD screen ==========================
# ============================= LVDS video ==========================
# setting of IOSTANDARD LVDS_25 is done in source code
set_property PACKAGE_PIN Y12 [get_ports -regexp -nocase lvds_channel_0_p]
set_property PACKAGE_PIN AA19 [get_ports -regexp -nocase lvds_channel_1_p]
set_property PACKAGE_PIN AA16 [get_ports -regexp -nocase lvds_channel_2_p]
set_property PACKAGE_PIN V16 [get_ports -regexp -nocase lvds_clk_p]
set_property IOSTANDARD TMDS_33 [get_ports -regexp -nocase lvds_channel_.*]
set_property IOSTANDARD TMDS_33 [get_ports -regexp -nocase lvds_clk_.*]
# ============================= Backlight ===========================
set_property PACKAGE_PIN Y14 [get_ports -regexp -nocase backlight_en]
set_property PACKAGE_PIN Y15 [get_ports -regexp -nocase backlight_pwm]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase backlight_en]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase backlight_pwm]

# set COMPENSATION property of PLL inside AXIS-2-LCD IP
set_property COMPENSATION "BUF_IN" [get_cells -hier -regexp {.*axis_to_lvds.*PLLE2_ADV.*}]

# ============================= HDMI out signals ===========================
set_property PACKAGE_PIN D3 [get_ports -regexp -nocase hdmi_out_clk]
set_property PACKAGE_PIN D2 [get_ports -regexp -nocase hdmi_out_vs]
set_property PACKAGE_PIN D1 [get_ports -regexp -nocase hdmi_out_hs]
set_property PACKAGE_PIN C1 [get_ports -regexp -nocase hdmi_out_de]
set_property PACKAGE_PIN H4 [get_ports -regexp -nocase {hdmi_out_data\[0\]}]
set_property PACKAGE_PIN H3 [get_ports -regexp -nocase {hdmi_out_data\[1\]}]
set_property PACKAGE_PIN F4 [get_ports -regexp -nocase {hdmi_out_data\[2\]}]
set_property PACKAGE_PIN G4 [get_ports -regexp -nocase {hdmi_out_data\[3\]}]
set_property PACKAGE_PIN G3 [get_ports -regexp -nocase {hdmi_out_data\[4\]}]
set_property PACKAGE_PIN G2 [get_ports -regexp -nocase {hdmi_out_data\[5\]}]
set_property PACKAGE_PIN E5 [get_ports -regexp -nocase {hdmi_out_data\[6\]}]
set_property PACKAGE_PIN F5 [get_ports -regexp -nocase {hdmi_out_data\[7\]}]
set_property PACKAGE_PIN H1 [get_ports -regexp -nocase {hdmi_out_data\[8\]}]
set_property PACKAGE_PIN E3 [get_ports -regexp -nocase {hdmi_out_data\[9\]}]
set_property PACKAGE_PIN B1 [get_ports -regexp -nocase {hdmi_out_data\[10\]}]
set_property PACKAGE_PIN E4 [get_ports -regexp -nocase {hdmi_out_data\[11\]}]
set_property PACKAGE_PIN F1 [get_ports -regexp -nocase {hdmi_out_data\[12\]}]
set_property PACKAGE_PIN B2 [get_ports -regexp -nocase {hdmi_out_data\[13\]}]
set_property PACKAGE_PIN G1 [get_ports -regexp -nocase {hdmi_out_data\[14\]}]
set_property PACKAGE_PIN F2 [get_ports -regexp -nocase {hdmi_out_data\[15\]}]
set_property PACKAGE_PIN A2 [get_ports -regexp -nocase {hdmi_out_data\[16\]}]
set_property PACKAGE_PIN A1 [get_ports -regexp -nocase {hdmi_out_data\[17\]}]
set_property PACKAGE_PIN B4 [get_ports -regexp -nocase {hdmi_out_data\[18\]}]
set_property PACKAGE_PIN B3 [get_ports -regexp -nocase {hdmi_out_data\[19\]}]
set_property PACKAGE_PIN C6 [get_ports -regexp -nocase {hdmi_out_data\[20\]}]
set_property PACKAGE_PIN C5 [get_ports -regexp -nocase {hdmi_out_data\[21\]}]
set_property PACKAGE_PIN A5 [get_ports -regexp -nocase {hdmi_out_data\[22\]}]
set_property PACKAGE_PIN A4 [get_ports -regexp -nocase {hdmi_out_data\[23\]}]
set_property PACKAGE_PIN E2 [get_ports -regexp -nocase hdmi_out_spdif]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase hdmi_out_.*]

# ============================= HDMI in signals ===========================
create_clock -period 6.734 -name hdmi_in_clk [get_ports hdmi_in_clk]

set_property PACKAGE_PIN K4 [get_ports -regexp -nocase hdmi_in_clk]
set_property PACKAGE_PIN P7 [get_ports -regexp -nocase hdmi_in_vs]
set_property PACKAGE_PIN L6 [get_ports -regexp -nocase hdmi_in_hs]
set_property PACKAGE_PIN P8 [get_ports -regexp -nocase hdmi_in_de]
set_property PACKAGE_PIN P5 [get_ports -regexp -nocase {hdmi_in_data\[0\]}]
set_property PACKAGE_PIN P6 [get_ports -regexp -nocase {hdmi_in_data\[1\]}]
set_property PACKAGE_PIN N5 [get_ports -regexp -nocase {hdmi_in_data\[2\]}]
set_property PACKAGE_PIN N6 [get_ports -regexp -nocase {hdmi_in_data\[3\]}]
set_property PACKAGE_PIN R2 [get_ports -regexp -nocase {hdmi_in_data\[4\]}]
set_property PACKAGE_PIN R3 [get_ports -regexp -nocase {hdmi_in_data\[5\]}]
set_property PACKAGE_PIN M1 [get_ports -regexp -nocase {hdmi_in_data\[6\]}]
set_property PACKAGE_PIN M2 [get_ports -regexp -nocase {hdmi_in_data\[7\]}]
set_property PACKAGE_PIN N3 [get_ports -regexp -nocase {hdmi_in_data\[8\]}]
set_property PACKAGE_PIN N4 [get_ports -regexp -nocase {hdmi_in_data\[9\]}]
set_property PACKAGE_PIN L1 [get_ports -regexp -nocase {hdmi_in_data\[10\]}]
set_property PACKAGE_PIN L2 [get_ports -regexp -nocase {hdmi_in_data\[11\]}]
set_property PACKAGE_PIN J1 [get_ports -regexp -nocase {hdmi_in_data\[12\]}]
set_property PACKAGE_PIN J2 [get_ports -regexp -nocase {hdmi_in_data\[13\]}]
set_property PACKAGE_PIN K8 [get_ports -regexp -nocase {hdmi_in_data\[14\]}]
set_property PACKAGE_PIN J8 [get_ports -regexp -nocase {hdmi_in_data\[15\]}]
set_property PACKAGE_PIN A7 [get_ports -regexp -nocase {hdmi_in_data\[16\]}]
set_property PACKAGE_PIN A6 [get_ports -regexp -nocase {hdmi_in_data\[17\]}]
set_property PACKAGE_PIN B7 [get_ports -regexp -nocase {hdmi_in_data\[18\]}]
set_property PACKAGE_PIN B6 [get_ports -regexp -nocase {hdmi_in_data\[19\]}]
set_property PACKAGE_PIN C8 [get_ports -regexp -nocase {hdmi_in_data\[20\]}]
set_property PACKAGE_PIN B8 [get_ports -regexp -nocase {hdmi_in_data\[21\]}]
set_property PACKAGE_PIN G6 [get_ports -regexp -nocase {hdmi_in_data\[22\]}]
set_property PACKAGE_PIN F6 [get_ports -regexp -nocase {hdmi_in_data\[23\]}]
#set_property PACKAGE_PIN J5 [get_ports hdmi_in_spdif]
set_property PACKAGE_PIN M6 [get_ports -regexp -nocase hdmi_in_rst_n]
set_property PACKAGE_PIN L4 [get_ports -regexp -nocase hdmi_in_int_n]
#set_property PACKAGE_PIN N8 [get_ports hdmi_in_hpd]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase hdmi_in_.*]

# ================ Ethernet phy ==========================
create_clock -period 8.000 -name rgmii_rxc [get_ports RGMII_rxc]

set_property PACKAGE_PIN T1 [get_ports -regexp -nocase RGMII_txc]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase RGMII_txc]
set_property PACKAGE_PIN K3 [get_ports -regexp -nocase RGMII_tx_ctl]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase RGMII_tx_ctl]

set_property PACKAGE_PIN U1 [get_ports -regexp -nocase {RGMII_td\[0\]}]
set_property PACKAGE_PIN K5 [get_ports -regexp -nocase {RGMII_td\[1\]}]
set_property PACKAGE_PIN R4 [get_ports -regexp -nocase {RGMII_td\[2\]}]
set_property PACKAGE_PIN R5 [get_ports -regexp -nocase {RGMII_td\[3\]}]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase RGMII_td.*]

set_property PACKAGE_PIN U2 [get_ports -regexp -nocase RGMII_rxc]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase RGMII_rxc]
set_property PACKAGE_PIN M3 [get_ports -regexp -nocase RGMII_rx_ctl]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase RGMII_rx_ctl]

set_property PACKAGE_PIN N1 [get_ports -regexp -nocase {RGMII_rd\[0\]}]
set_property PACKAGE_PIN P1 [get_ports -regexp -nocase {RGMII_rd\[1\]}]
set_property PACKAGE_PIN P3 [get_ports -regexp -nocase {RGMII_rd\[2\]}]
set_property PACKAGE_PIN P2 [get_ports -regexp -nocase {RGMII_rd\[3\]}]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase RGMII_rd.*]

set_property PACKAGE_PIN K2 [get_ports -regexp -nocase MDIO_PHY_mdc]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase MDIO_PHY_mdc]
set_property PACKAGE_PIN J3 [get_ports -regexp -nocase mdio_phy_mdio_io]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase mdio_phy_mdio_io]

set_property PACKAGE_PIN K7 [get_ports -regexp -nocase eth_reset_n]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase eth_reset_n]
set_property PACKAGE_PIN L7 [get_ports -regexp -nocase eth_int_n]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase eth_int_n]

# Create clock for 125Mhz clock that is comming from the Ethernet PHY on the Florida
create_clock -period 8.000 -name clk_125MHz [get_ports CLK125_NDO]
set_property PACKAGE_PIN T2 [get_ports -regexp -nocase CLK125_NDO]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase CLK125_NDO]

# =============== IDELAY for RGMII ============
set_property IDELAY_VALUE 16 [get_cells -hierarchical -filter {NAME =~ *delay_rgmii_rx_ctl*}]
set_property IDELAY_VALUE 16 [get_cells -hierarchical -filter {NAME =~ *delay_rgmii_rxd*}]
set_property IODELAY_GROUP gpr1 [get_cells -hierarchical -filter {NAME =~ *delay_rgmii_rx_ctl*}]
set_property IODELAY_GROUP gpr1 [get_cells -hierarchical -filter {NAME =~ *delay_rgmii_rxd*}]
set_property IODELAY_GROUP gpr1 [get_cells -hierarchical *idelayctrl]

# ================== TOUCH IRQ ========================
set_property PACKAGE_PIN J7 [get_ports -regexp -nocase touch_irq_n]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase touch_irq_n]
set_property PULLUP true [get_ports -regexp -nocase touch_irq_n]

# ================== UART's ========================
# connect to RTS_N of UART chip on Florida
set_property PACKAGE_PIN V14 [get_ports -regexp -nocase UART1_CTSN]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase UART1_CTSN]
# connect to TX of UART chip on Florida
set_property PACKAGE_PIN U16 [get_ports -regexp -nocase UART1_RX]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase UART1_RX]
set_property PULLUP true [get_ports -regexp -nocase UART1_RX]

# connect to CTS_N of UART chip on Florida
set_property PACKAGE_PIN U19 [get_ports -regexp -nocase UART1_RTSN]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase UART1_RTSN]
# connect to RX of UART chip on Florida
set_property PACKAGE_PIN V19 [get_ports -regexp -nocase UART1_TX]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase UART1_TX]

# ===================== User LED Miami =====================
set_property PACKAGE_PIN T16 [get_ports -regexp -nocase user_led]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase user_led]

# ================ External clock inputs ================
# Clock from Miami (DSC1001)
create_clock -period 10.173 -name clock98mhz [get_ports clock98mhz]
set_property PACKAGE_PIN L5 [get_ports -regexp -nocase clock98mhz]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase clock98mhz]

# CDCE chip (Y2)
create_clock -period 81.380 -name hdmi_out_spdif_clk [get_ports hdmi_out_spdif_clk]
set_property PACKAGE_PIN AA14 [get_ports -regexp -nocase hdmi_out_spdif_clk]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase hdmi_out_spdif_clk]

# CDCE chip (Y4)
create_clock -period 6.734 -name cdce_y4_clk [get_ports cdce_y4_clk]
set_property PACKAGE_PIN D5 [get_ports -regexp -nocase cdce_y4_clk]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase cdce_y4_clk]

# ================ PUSH BUTTONS =======================
set_property PACKAGE_PIN AA15 [get_ports -regexp -nocase button_s2]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase button_s2]
set_property PACKAGE_PIN M4 [get_ports -regexp -nocase button_s3]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase button_s3]

# ====================== LEDS ==================
# D2 (green)
set_property PACKAGE_PIN AB18 [get_ports -regexp -nocase {LEDS\[0\]}]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase {LEDS\[0\]}]
# D3 (yellow)
set_property PACKAGE_PIN AB19 [get_ports -regexp -nocase {LEDS\[1\]}]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase {LEDS\[1\]}]
# D4 (red)
set_property PACKAGE_PIN C4 [get_ports -regexp -nocase {LEDS\[2\]}]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase {LEDS\[2\]}]
# D5 (green)
set_property PACKAGE_PIN J6 [get_ports -regexp -nocase  {LEDS\[3\]}]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase {LEDS\[3\]}]
# D6 (green)
set_property PACKAGE_PIN R7 [get_ports -regexp -nocase {LEDS\[4\]}]
set_property IOSTANDARD LVCMOS18 [get_ports -regexp -nocase  {LEDS\[4\]}]

# ====================== PMOD 0 X99 ==================
# pin 1
set_property PACKAGE_PIN W12 [get_ports -regexp -nocase {pmods_tri_io\[0\]}]
# pin 2
set_property PACKAGE_PIN W13 [get_ports -regexp -nocase {pmods_tri_io\[1\]}]
# pin 3
set_property PACKAGE_PIN AB13 [get_ports -regexp -nocase {pmods_tri_io\[2\]}]
# pin 4
set_property PACKAGE_PIN AB14 [get_ports -regexp -nocase {pmods_tri_io\[3\]}]
# pin 7
set_property PACKAGE_PIN V11 [get_ports -regexp -nocase {pmods_tri_io\[4\]}]
# pin 8
set_property PACKAGE_PIN W11 [get_ports -regexp -nocase {pmods_tri_io\[5\]}]
# pin 9
set_property PACKAGE_PIN AB16 [get_ports -regexp -nocase {pmods_tri_io\[6\]}]
# pin 10
set_property PACKAGE_PIN AB17 [get_ports -regexp -nocase {pmods_tri_io\[7\]}]

set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase pmods_tri_io.*]

# ====================== PMOD 1 X100 ==================
# pin 1
set_property PACKAGE_PIN R17 [get_ports -regexp -nocase {pmods_tri_io\[8\]}]
# pin 2
set_property PACKAGE_PIN T17 [get_ports -regexp -nocase {pmods_tri_io\[9\]}]
# pin 3
set_property PACKAGE_PIN AB21 [get_ports -regexp -nocase {pmods_tri_io\[10\]}]
# pin 4
set_property PACKAGE_PIN AB22 [get_ports -regexp -nocase {pmods_tri_io\[11\]}]
# pin 7
set_property PACKAGE_PIN W17 [get_ports -regexp -nocase {pmods_tri_io\[12\]}]
# pin 8
set_property PACKAGE_PIN Y17 [get_ports -regexp -nocase {pmods_tri_io\[13\]}]
# pin 9
set_property PACKAGE_PIN V18 [get_ports -regexp -nocase {pmods_tri_io\[14\]}]
# pin 10
set_property PACKAGE_PIN W18 [get_ports -regexp -nocase {pmods_tri_io\[15\]}]

set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase pmods_tri_io.*]

# ====================== PMOD 2 X101 ==================
# Using PMOD Extended SPI interface 2A
# pin 1: SS
set_property PACKAGE_PIN V15 [get_ports -regexp -nocase {pmod2_spi_ss}]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase {pmod2_spi_ss}]
# pin 2: MOSI
set_property PACKAGE_PIN W15 [get_ports -regexp -nocase {pmod2_spi_mosi}]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase {pmod2_spi_mosi}]
# pin 3: MISO
set_property PACKAGE_PIN U17 [get_ports -regexp -nocase {pmod2_spi_miso}]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase {pmod2_spi_miso}]
# pin 4: SCK
set_property PACKAGE_PIN U18 [get_ports -regexp -nocase {pmod2_spi_sck}]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase {pmod2_spi_sck}]
# pin 7: INT
set_property PACKAGE_PIN U13 [get_ports -regexp -nocase {pmod2_int}]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase {pmod2_int}]
# pin 8: RESET
set_property PACKAGE_PIN U14 [get_ports -regexp -nocase {pmod2_rst}]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase {pmod2_rst}]
# pin 9: N/S
set_property PACKAGE_PIN U11 [get_ports -regexp -nocase {pmod2_ns9}]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase {pmod2_ns9}]
# pin 10: N/S
set_property PACKAGE_PIN U12 [get_ports -regexp -nocase {pmod2_ns10}]
set_property IOSTANDARD LVCMOS33 [get_ports -regexp -nocase {pmod2_ns10}]
